#ifndef __CAPDEV_HEADER_INCLUDED__
#define __CAPDEV_HEADER_INCLUDED__

#include <g_globals.h>
#include <lists.h>

#define CAP_STATE_NULL          0x00000000
#define CAP_STATE_INIT          0x00000001
#define CAP_STATE_CAPTURE       0x00000002
#define CAP_STATE_ENDED         CAP_STATE_NULL

typedef void *(*proc_thread)(void *);
typedef void *(*proc_capdev_init)(char *, char *);
typedef int (*proc_capdev_end)(void *);
typedef struct packet *(*proc_capdev_poll)(void *);

typedef struct captype {
	list_head_t     	l;

	char			*name;
	proc_capdev_init	init;
	proc_capdev_end		end;
	proc_capdev_poll	poll;
}captype_t, *p_captype;

typedef struct capdev{
	list_head_t	l;

	p_captype	capture;
	
	uint		state;
	char		*interface;
	char		*filter;

	void		*priv;
	pthread_t	thread;	
	proc_thread	thread_proc;
}capdev_t, *p_capdev;

int capdev_init (void);
p_captype capdev_find_type(char *name);

int capdev_add(char *type, char *interface, char *filter, proc_thread proc);

void capdev_init_all(void);
void capdev_start_all(void);
void capdev_end_all(int, void *);

/* Given to captype plugins */
typedef int (*proc_add_captype)(char *, proc_capdev_init,
		proc_capdev_end,
		proc_capdev_poll);

int capdev_add_type(char *name, proc_capdev_init i,
		proc_capdev_end e,
	       	proc_capdev_poll p);

#endif //__LOADER_HEADER_INCLUDED__
