#ifndef __RULESET_SNORT_PLUGIN_HEADER_INCLUDED__
#define __RULESET_SNORT_PLUGIN_HEADER_INCLUDED__

#include <g_globals.h>
#include <s_globals.h>
#include <matcher.h>
#include <plugins.h>

typedef struct snort {
	list_head_t	l;
	char		*key;
	char 		*val;
}snort_t, *p_snort;

typedef enum snort_e {
	SNORT_NULL,
	SNORT_BACKWARDS,
	SNORT_FORWARDS,
	SNORT_BIDIRECTIONAL
}snort_ret;

/* Parse one single rule */
snort_ret snort_parse_rule(char *rule);
int snort_parse_body(char *body);

/* Add item to internal list, and cleanup internal list */
int snort_link_element(const char *key, const char *val);
void snort_cleanup_internal(void);

int snort_optimise_rule(p_snort tokens);
int snort_invert_rule(p_snort tokens);

int snort_add_rule(void);

#define IS_RULE(x) ( \
	x[0] != '\0' && \
	x[0] != '#'  && \
	x[0] != '\n' && \
	x[0] != '\r' )

#endif /* __RULESET_SNORT_PLUGIN_HEADER_INCLUDED__ */
