#ifndef __TARGETS_HEADER_INCLUDED__
#define __TARGETS_HEADER_INCLUDED__
/* 
* TARGETS.H
* Managaes all installed targets, also
* contains target_add(), which plugins call
* to register new targets
*/

#include <g_globals.h>
#include <packet.h>
#include <lists.h>

typedef void (*proc_target)(p_packet, void *);
typedef void *(*proc_target_validate)(char *);
typedef void (*proc_target_cleanup)(void *);

typedef struct target {
	list_head_t 		l;
	char			*name;
	proc_target		target;
	proc_target_validate	validate;
	proc_target_cleanup	cleanup;
}target_t, *p_target;

/* Initialise targets subsystem  */
int target_init(void);

/* Get a target by its name */
p_target target_get(char *);

typedef int (*proc_target_add)(char *, proc_target,
	proc_target_validate, proc_target_cleanup);

#ifndef __PLUGIN__
int target_add(char *, proc_target, proc_target_validate, proc_target_cleanup);
#endif

#endif //__TARGETS_HEADER_INCLUDED__
