#include <alert.h>
#include <s_util.h>

proc_print_out		print_out;
proc_print_raw		print_raw;
proc_target_add		add_target;

void alert_cleanup(void *priv)
{
	if (priv) free(priv);
}

void alert_target(p_packet p, void *priv)
{
	int i;
	
	print_out("%s - ", priv);
	for (i=0; p->layer[i].id; i++) {
		print_out("%s -> ", p->layer[i].name);
	}print_out(": PORTS %i -> %i" CRLF, p->sport, p->dport);	
}

void *alert_validate(char *token)
{
	char *tmp;
	
	if ( !token ) return NULL;

	if ( !(tmp=strdup((token))) ) {
		return NULL;
	}

	return tmp;
}

uint _PLUGIN_INIT (p_plugin_in in, p_plugin_out out)
{
	PLUGIN_CHECK_PARAMS(in);

	print_out=in->print_out;
	print_raw=in->print_raw;
	add_target=in->add_target;
	
	out->name="Alert";
	out->desc="Prints successful matches to screen";
	out->ver_major=1;
	out->ver_minor=0;
	
	add_target("ALERT",
		alert_target,
		alert_validate,
		alert_cleanup);
	
	return PLUGIN_ERR_OK;
}

/* This is where we would cleanup our shit */
uint _PLUGIN_UNLOAD (void)
{
	return PLUGIN_ERR_OK;
}
